unit uVr2MEMO;
 {*** Oplossing vir Vraag 2 - class ***}
interface

TYPE
   TVr2 = class(TObject)
     private
       fDTipe    : String;
       fAantal   : Integer;
       fGrootte : Real;
       fKat      : Char;

     public
       constructor Create(sDTipe: String; iAantal : integer; rGrootte : Real; cKat : Char); 
       function isGeskik(cKat : char; iAantal : Integer) : Boolean;
       function toString : String;

       procedure setDTipe(sDTipe : String);
       procedure setAantal(iNumber : Integer);
       procedure setGrootte(rSize : Real);
       procedure setKat(cKat : Char);
       function getDTipe:String;
       function getAantal:integer;
       function getSize:real;
       function getKat:Char;
   end;

implementation

uses SysUtils;

{ TQuest2 }

constructor TVr2.Create(sDTipe: String; iAantal: integer; rGrootte: Real;
  cKat: Char);
begin
   fDTipe    := sDTipe;
   fAantal   := iAantal;
   fGrootte  := rGrootte;
   fKat      := cKat;
end;

function TVr2.isGeskik(cKat: char; iAantal: integer): Boolean;
var
   rSpasie : real;
begin
    Result := false;
    if fDTipe = 'XXX'
    then
     begin
       rSpasie := fGrootte / iAantal;
       case cKat of
        'G' : Result := rSpasie >= 18;
        'M' : Result := (rSpasie >= 12) AND (rSpasie < 18);
        'K' : Result := (rSpasie >= 7)  AND (rSpasie < 12);
       end;
     end;
end;

function TVr2.toString: String;
begin
    Result := fDTipe + '...' + fKat + #13 +
              'Kampgrootte: ' + FloatToStrF(fGrootte, ffFixed,8,1) + #13 +
              'Aantal diere: ' + IntToStr(fAantal) + #13 + #13;
end;

procedure TVr2.setDTipe(sDTipe: String);
begin
   fDTipe := sDTipe;
end;

procedure TVr2.setGrootte(rSize: Real);
begin
   fGrootte := rSize;
end;

procedure TVr2.setKat(cKat: Char);
begin
   fKat := cKat;
end;

procedure TVr2.setAantal(iNumber: Integer);
begin
   fAantal := iNumber;
end;

function TVr2.getDTipe:String;
begin
   Result := fDTipe;
end;

function TVr2.getAantal:integer;
begin
   Result := fAantal;
end;

function TVr2.getSize:real;
begin
   Result := fGrootte;
end;

function TVr2.getKat:Char;
begin
   Result := fKat;
end;


end.
