unit Vraag2MEMO;
  {*** Oplossing vraag 2 - vorm unit ***}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Menus,
  uVr2MEMO;

type
  TfrmQ2 = class(TForm)
    mnuMain: TMainMenu;
    mnuOpsieA: TMenuItem;
    mnuVerlaat: TMenuItem;
    redQ2: TRichEdit;
    mnuOpsieB: TMenuItem;
    procedure mnuVerlaatClick(Sender: TObject);
    procedure mnuOpsieAClick(Sender: TObject);
    procedure mnuOpsieBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmQ2: TfrmQ2;
  KampArr   : Array[1..30] of TVr2;
  iTeller  : integer;

implementation

{$R *.dfm}
{$R+}

procedure TfrmQ2.FormCreate(Sender: TObject);
var
   TLeer         : TexTLeer;
   iPos, iAantal : integer;
   rGrootte      : real;
   cKat          : char;
   sReel, sDier  : string;
begin
   if FileExists ('DataV2.txt') <> true    then
     begin
       ShowMessage('Die leer bestaan nie.');
       Exit;
     end;
   AssignFile(TLeer, 'DataV2.txt');
   Reset(TLeer);

   iTeller := 0;
   while (not EOF(TLeer) ) do
   begin
     inc(iTeller);
     readln(TLeer, sReel);
     iPos := pos(';', sReel);
     sDier := copy(sReel, 1, iPos -1);
     delete(sReel, 1, iPos);

     iPos := pos('#', sReel);
     iAantal := StrToInt(copy(sReel, 1, iPos -1));
     delete(sReel, 1, iPos);

     iPos := pos(';', sReel);
     rGrootte := StrToFloat(copy(sReel, 1, iPos -1));
     delete(sReel, 1, iPos);

     cKat := sReel[1];

     KampArr[iTeller] := TVr2.Create(sDier, iAantal, rGrootte, cKat);
   end;
   closeFile(TLeer);
end;

procedure TfrmQ2.mnuOpsieAClick(Sender: TObject);
var
 K :integer;
begin
     redQ2.Lines.Add('Lys van al die kampe');
     redQ2.Lines.Add('====================');
     For K := 1 to iTeller do
       begin
          redQ2.Lines.Add('Kampnommer: ' + IntToStr(K) + #13 +
                                     KampArr[K].toString);
       end;
end;

procedure TfrmQ2.mnuOpsieBClick(Sender: TObject);
var
  K, iNom : integer;
  bGevind : boolean;
  cKat    : char;
  sDTipe  : String;
begin
  sDTipe := InputBox('Tipe dier', 'Sleutel die tipe dier in byvoorbeeld Tier.','Tier');
  iNum := StrToInt(InputBox('Aantal diere', 'Sleutel die aantal diere in byvoorbeeld 2.','2'));
  cKat := InputBox('Kategorie', 'Sleutel die kategorie in (G/M/K)','G')[1];
  bGevind := false;
  K := 1;
  While (bGevind <> true) and (K <= iTeller) do
   begin
    if  KampArr[K].isGeskik(cKat, iNom)  then
       begin
         KampArr[K].setDTipe(sDTipe);
         KampArr[K].setKat(cKat);
         KampArr[K].setAantal(iNom);
         bGevind := true;
       end
     else
      inc(K);
    end;
    redQ2.Lines.Clear;
    if NOT(bGevind) then
      redQ2.Lines.Add('Geen geskikte kamp is gevind nie.')
    else
      begin
         redQ2.Lines.Clear;
         redQ2.Lines.Add('Hierdie diere is in kampnommer ' + IntToStr(K) +
                                  ' geplaas.');
         redQ2.Lines.Add(' ');
         mnuOpsieA.Click;
      end;end;

procedure TfrmQ2.mnuVerlaatClick(Sender: TObject);
begin
  Application.Terminate;
end;

end.
